Name:           spoofer
Version:        1.4.12
Release:        %{autorelease}
Summary:        Software to test source address validation

License:        GPL-3.0-or-later WITH GPL-3.0-linking-source-exception
URL:            https://www.caida.org/projects/spoofer/
Source0:        %{url}/downloads/spoofer-%{version}.tar.gz
Source1:        spoofer-gui.desktop
Source2:        spoofer-gui.metainfo.xml

BuildRequires:  gcc-c++
BuildRequires:  libpcap-devel
BuildRequires:  make
BuildRequires:  openssl-devel
BuildRequires:  protobuf-compiler
BuildRequires:  protobuf-devel
BuildRequires:  qt5-qttools-devel
BuildRequires:  traceroute
BuildRequires:  desktop-file-utils
BuildRequires:  libappstream-glib
# Generate man pages
BuildRequires:  help2man
Requires: %{name}-cli%{?_isa} = %{version}-%{release}
Requires: %{name}-gui%{?_isa} = %{version}-%{release}
Requires: %{name}-prober%{?_isa} = %{version}-%{release}
Requires: %{name}-scheduler%{?_isa} = %{version}-%{release}

%description
The spoofer program attempts to send a series of spoofed UDP packets to servers
distributed throughout the world. These packets are designed to test:
- Different classes of spoofed IPv4 and IPv6 addresses, including private and
routable
- Ability to spoof neighboring, adjacent addresses
- Ability to spoof inbound (towards the client) and outbound (from the client)
- Where along the path filtering is observed
- Presence of a NAT device along the path

%package cli
Summary: %{summary}
Requires: %{name}-license = %{version}-%{release}
Provides: spoofer-cli%{?_isa} = %{version}-%{release}

%description cli
Command line only program to check spoofed IPv4 and IPv6 internet addresses.


%package gui
Summary: %{summary}
Requires: %{name}-license
Requires: hicolor-icon-theme
Provides: spoofer-gui%{?_isa} = %{version}-%{release}

%description gui
Graphical user interface program to check spoofed IPv4 and IPv6 internet
addresses.


%package prober
Summary: %{summary}
Requires: %{name}-license
Provides: spoofer-prober%{?_isa} = %{version}-%{release}

%description prober
Prober to check spoofed IPv4 and IPv6 internet addresses.


%package scheduler
Summary: %{summary}
Requires: %{name}-license
Provides: spoofer-scheduler%{?_isa} = %{version}-%{release}

%description scheduler
Scheduler to check spoofed IPv4 and IPv6 internet addresses.


%package license
Summary: %{summary}
BuildArch: noarch
Provides: spoofer-license = %{version}-%{release}

%description license
License file for programs to check spoofed IPv4 and IPv6 internet addresses.


%prep
%autosetup

%build
%configure
%make_build
help2man --version-string='%{version}' --no-discard-stderr --no-info \
         --name='%{summary}' --output=spoofer-cli.1 manager/cli/spoofer-cli
help2man --version-string='%{version}' --no-discard-stderr --no-info \
         --name='%{summary}' --output=spoofer-scheduler.1 \
         manager/scheduler/spoofer-scheduler
help2man --version-string='%{version}' --no-discard-stderr  --no-info \
         --name='%{summary}' --output=spoofer-prober.1 prober/spoofer-prober

%install
%make_install
install -D -m 644 spoofer-cli.1 %{buildroot}/%{_mandir}/man1/spoofer-cli.1
install -D -m 644 spoofer-scheduler.1 %{buildroot}/%{_mandir}/man1/spoofer-scheduler.1
install -D -m 644 spoofer-prober.1 %{buildroot}/%{_mandir}/man1/spoofer-prober.1
install -D -m 644 icons/spoofer16.png %{buildroot}/%{_datadir}/icons/hicolor/16x16/apps/spoofer-gui.png
install -D -m 644 icons/spoofer32.png %{buildroot}/%{_datadir}/icons/hicolor/32x32/apps/spoofer-gui.png
install -D -m 644 icons/spoofer48.png %{buildroot}/%{_datadir}/icons/hicolor/48x48/apps/spoofer-gui.png
install -D -m 644 icons/spoofer64.png %{buildroot}/%{_datadir}/icons/hicolor/64x64/apps/spoofer-gui.png
install -D -m 644 icons/spoofer128.png %{buildroot}/%{_datadir}/icons/hicolor/128x128/apps/spoofer-gui.png
install -D -m 644 icons/spoofer256.png %{buildroot}/%{_datadir}/icons/hicolor/256x256/apps/spoofer-gui.png
install -D -m 644 %{SOURCE2} %{buildroot}%{_metainfodir}/spoofer-gui.metainfo.xml
desktop-file-install --dir=%{buildroot}%{_datadir}/applications %{SOURCE1}

%check
make check
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/*.metainfo.xml

%files

%files cli
%{_bindir}/spoofer-cli
%{_mandir}/man1/spoofer-cli.1*

%files gui
%{_bindir}/spoofer-gui
%{_datadir}/icons/hicolor/16x16/apps/spoofer-gui.png
%{_datadir}/icons/hicolor/32x32/apps/spoofer-gui.png
%{_datadir}/icons/hicolor/48x48/apps/spoofer-gui.png
%{_datadir}/icons/hicolor/64x64/apps/spoofer-gui.png
%{_datadir}/icons/hicolor/128x128/apps/spoofer-gui.png
%{_datadir}/icons/hicolor/256x256/apps/spoofer-gui.png
%{_datadir}/applications/spoofer-gui.desktop
%{_metainfodir}/spoofer-gui.metainfo.xml

%files prober
%{_bindir}/spoofer-prober
%{_mandir}/man1/spoofer-prober.1*

%files scheduler
%{_bindir}/spoofer-scheduler
%{_mandir}/man1/spoofer-scheduler.1*

%files license
%license LICENSE
%doc README

%changelog
%autochangelog
